﻿using System.Data;
using System.Data.Common;
using System.Data.SqlClient;
using System.Threading.Tasks;
using Microsoft.Data.Entity;
using Nito.AsyncEx;

namespace EntityFrameworkCoreStoredProcCall.Console
{
    class Program
    {
        private MyContext _context;

        static void Main(string[] args)
        {
            Program p = new Program();
            AsyncContext.Run(p.ExecuteStoredProc);
        }

        private async Task ExecuteStoredProc()
        {
            DbCommand cmd = _context.Database.GetDbConnection().CreateCommand();

            cmd.CommandText = "dbo.sp_DoSomething";
            cmd.CommandType = CommandType.StoredProcedure;

            cmd.Parameters.Add(new SqlParameter("@firstName", SqlDbType.VarChar) { Value = "Steve" });
            cmd.Parameters.Add(new SqlParameter("@lastName", SqlDbType.VarChar) { Value = "Smith" });

            cmd.Parameters.Add(new SqlParameter("@id", SqlDbType.BigInt) { Direction = ParameterDirection.Output });

            if (cmd.Connection.State != ConnectionState.Open)
            {
                cmd.Connection.Open();
            }

            await cmd.ExecuteNonQueryAsync();

            long id = (long)cmd.Parameters["@lId"].Value;

        }
        private Program()
        {
            var dbContextOptionsBuilder = new DbContextOptionsBuilder();

            dbContextOptionsBuilder.UseSqlServer(System.Configuration.ConfigurationManager.
                ConnectionStrings["EntityFrameworkCoreStoredProcCall"].ConnectionString);

            _context = new MyContext(dbContextOptionsBuilder.Options);
        }

    }
}
